﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Autodesk.Navisworks.Api;

using ComApi = Autodesk.Navisworks.Api.Interop.ComApi;
using ComApiBridge = Autodesk.Navisworks.Api.ComApi;

namespace DevTV_Navisworks_Plugins
{
    public partial class usercontrol_for_dockpane : UserControl
    {
        public usercontrol_for_dockpane()
        {
            InitializeComponent();
        }
 
        private void button1_Click(object sender, EventArgs e)
        { 
            dumpModelTree();   
        }
        
        private void dumpModelTree()
        {

            Document oDoc = Autodesk.Navisworks.Api.Application.ActiveDocument;

            //  为简化，只考察第一个model
            if (oDoc.Models.Count == 1)
            {
                treeView1.Nodes.Clear();

                ModelItem rootItem = Autodesk.Navisworks.Api.Application.ActiveDocument.Models[0].RootItem;

                TreeNode oRootNode = treeView1.Nodes.Add(rootItem.DisplayName);
                oRootNode.Tag = rootItem;

                recurse(rootItem, oRootNode);
            }
        }

        private void recurse(ModelItem oParentModItem, TreeNode oParentNode)
        {
            foreach (ModelItem oSubModItem in oParentModItem.Children)
            {
                string nodeName = "";
               
                if (string.IsNullOrEmpty(oSubModItem.DisplayName))
                {
                    if (oSubModItem.IsInsert)
                        nodeName = oSubModItem.Children.ElementAt<ModelItem>(0).DisplayName;

                    if (oSubModItem.HasGeometry)
                        nodeName = oSubModItem.ClassDisplayName;
                }
                else
                {
                    nodeName = oSubModItem.DisplayName;                               
                }               

                TreeNode oSubNode = oParentNode.Nodes.Add(nodeName);
                oSubNode.Tag = oSubModItem;

                recurse(oSubModItem, oSubNode);
            }
        }

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            if (e.Node.Tag != null)
            {
                try
                {

                    ModelItem item = e.Node.Tag as ModelItem;
                    ModelItemCollection oColl = new ModelItemCollection();
                    oColl.Add(item);

                    Document oDoc = Autodesk.Navisworks.Api.Application.ActiveDocument;
                    oDoc.CurrentSelection.CopyFrom(oColl);

                    ComApiBridge.ComApiBridge.State.ZoomInCurViewOnCurSel();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
        }
    }
}
